<template>
  <div class="w-full">
    <div class="h-[150px] relative">
      <div
        class="GameImgSBOLive-en gameImage img-resize backgroundAdjuest load-game-mobile-version"
        @click="
          authenticated
            ? handleGameClick(gameForDisplay, false)
            : toggleLoginRegisterDialog()
        "
      ></div>
      <div class="h-[66px] bg-background3 rounded-b-[5px]">
        <span
          class="inline-block text-center font-bold py-[2px] px-[15px] text-white bg-transparent border-none overflow-hidden whitespace-nowrap text-ellipsis w-full text-[9px]"
        >
          {{ gameForDisplay.EnglishGameName }}
        </span>
        <div class="text-[10px] -mt-[5px]">
          <div v-if="!showOption" @click="showOption = true">
            <div class="uppercase">
              <span
                class="mt-[10px] text-[9px] p-[5px] text-[var(--text)] border-[1px] rounded-[5px] justify-center flex mx-[5px]"
              >
                {{ $t("play_game") }}
              </span>
            </div>
          </div>
          <div
            v-if="showOption"
            class="flex absolute bg-background3 border-[0.5px] text-[var(--text)] w-full h-full top-0 left-0 rounded-[5px] uppercase justify-center items-center"
          >
            <div class="">
              <div class="">
                <div
                  class="border-[1px] border-white py-[5px] px-[15px] rounded-[5px] mb-[10px]"
                  @click="
                    authenticated
                      ? handleGameClick(gameForDisplay, true)
                      : toggleLoginRegisterDialog()
                  "
                >
                  {{ $t("desktop_view") }}
                </div>
                <div
                  class="border-[1px] border-white py-[5px] px-[15px] rounded-[5px]"
                  @click="
                    authenticated
                      ? handleGameClick(gameForDisplay, false)
                      : toggleLoginRegisterDialog()
                  "
                >
                  {{ $t("mobile_view") }}
                </div>
              </div>
              <font-awesome-icon
                class="absolute right-[15px] top-[15px] text-lg"
                icon="circle-xmark"
                @click="showOption = false"
              />
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, PropType, computed, ref } from "vue";
import { IGameBsi } from "@/models/bsiGameList";
import { store } from "@/store";
import { handleGameEntryOpenWindow } from "@/composables/useTheme";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";
import SportDisplayModel from "@/components/sport/sportDisplayModel";
import { IGame } from "@/models/IGetPlayableGamesResponse";

export default defineComponent({
  name: "VerticalGameEntryComponent",
  props: {
    game: {
      type: Object as PropType<IGameBsi>,
      required: true,
    },
  },
  setup(props) {
    const gameForDisplay = computed(() => new SportDisplayModel(props.game));
    const authenticated = computed(() => store.state.auth);
    const { toggleLoginRegisterDialog } = commonHelper;
    const showOption = ref(false);
    const gameImage = computed(() => `url(${gameForDisplay.value.GameIconUrl}`);
    const entrance = EnumEntranceLocation.Other;
    const config = useRuntimeConfig();
    const router = useRouter();
    const handleGameClick = (game: IGame, viewAsDesktop: boolean) => {
      const isDemo = config.public.CURRENTLY_ENV === "demo";
      const isWebId8 = store.state.webId === 8;
      if (isDemo && isWebId8) {
        router.push(`/game/${game.GameId}?location=${entrance}&silent`);
      } else {
        handleGameEntryOpenWindow(game, 550, 850, entrance, viewAsDesktop);
      }
    };

    return {
      gameForDisplay,
      authenticated,
      handleGameEntryOpenWindow,
      gameImage,
      showOption,
      entrance,
      handleGameClick,
      toggleLoginRegisterDialog,
    };
  },
});
</script>

<style scoped lang="scss">
.gameImage {
  height: 55%;
}
.gameImage {
  border-radius: 5px 5px 0px 0px;
}
.backgroundAdjuest {
  background: var(--background3) v-bind(gameImage) center/contain no-repeat;
}
.box-entry {
  height: 154.05px;
  position: relative;
  border-radius: 10px;
  box-sizing: border-box;
  border: 1px solid #393c68;
  width: 100%;
  overflow: hidden;
  cursor: pointer;

  .footer-entry {
    height: 35%;
    width: 100%;
    position: absolute;
    z-index: 1;
    bottom: 0;
    left: 0;
    color: var(--text5);

    .background-play-game {
      background-color: #393c68;
      opacity: 0.8;
      width: 100%;
      height: 100%;
      position: absolute;
      z-index: 0;
    }

    .game-name {
      margin-top: 2%;
      height: 50px;
      display: block;
      font-family: sans-serif;
      line-height: 40px;
      text-overflow: ellipsis;
      white-space: nowrap;
      font-size: 14px;
      text-align: center;
    }

    .btn-play-game {
      background: #ff4e00;
      border: 1px solid #ff4e00;
      border-radius: 25px;
      font-size: 16px;
      font-weight: 700;
      padding: 5px 20px;
      width: 100%;

      &:hover,
      &:focus {
        background: #009fe3;
        border-color: #009fe3;
        color: black;
      }
    }
  }
}
</style>
